> For clean Markdown of any page, append .md to the page URL. > For a complete documentation index, see https://reference.flatfile.com/api-reference/sheets/get-cell-values/llms.txt. > For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server. # Get record cells by field GET https://api.x.flatfile.com/v1/sheets/{sheetId}/cells Returns record cell values grouped by all fields in the sheet Reference: https://reference.flatfile.com/api-reference/sheets/get-cell-values ## Authentication - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `sheetId` (string, required) — ID of sheet ### Query parameters - `fieldKey` (string, optional) — Returns results from the given field only. Otherwise all field cells are returned - `sortField` (string, optional) — Name of field by which to sort records - `sortDirection` (enum, optional) — Sort direction - asc (ascending) or desc (descending) - Allowed values: `asc`, `desc` - `filter` (enum, optional) — Options to filter records - Allowed values: `valid`, `error`, `all`, `none` - `filterField` (string, optional) — Name of field by which to filter records - `pageSize` (integer, optional) — Number of records to return in a page (default 1000 if pageNumber included) - `pageNumber` (integer, optional) — Based on pageSize, which page of records to return - `distinct` (boolean, required) — Must be set to true - `includeCounts` (boolean, optional) — When both distinct and includeCounts are true, the count of distinct field values will be returned - `searchValue` (string, optional) — A value to find for a given field in a sheet. Wrap the value in "" for exact match - `q` (string, optional) — An FFQL query used to filter the records to be queried ## Response ### 200 - `data` (map from string to list of CellValueWithCounts, required) — Cell values grouped by field key ## Types ### CellValueWithCounts - `counts` (RecordCounts, optional) - `layer` (string, optional) - `messages` (list of ValidationMessage, optional) - `updatedAt` (datetime, optional) - `valid` (boolean, optional) - `value` (CellValueUnion, optional) - `metadata` (map from string to any, optional, deprecated) — Deprecated, use record level metadata instead. ### RecordCounts - `total` (integer, required) - `valid` (integer, required) - `error` (integer, required) - `byField` (map from string to FieldRecordCounts, optional) — Counts for valid, error, and total records grouped by field key - `errorsByField` (map from string to integer, optional, deprecated) ### ValidationMessage Record data validation messages - `field` (string, optional) - `type` (enum, optional) - Allowed values: `error`, `warn`, `info` - `source` (enum, optional) - Allowed values: `required-constraint`, `unique-constraint`, `custom-logic`, `unlinked`, `invalid-option`, `is-artifact` - `message` (string, optional) - `path` (string, optional) — This JSONPath is based on the root of mapped cell object. ### CellValueUnion ### FieldRecordCounts - `total` (integer, required) - `valid` (integer, required) - `error` (integer, required) - `empty` (integer, required) ## Examples **Response** ```json { "data": { "firstName": [ { "counts": { "total": 1, "valid": 1, "error": 0 }, "valid": true, "value": "Mike" }, { "counts": { "total": 1, "valid": 1, "error": 0 }, "valid": true, "value": "Jordan" } ] } } ``` **SDK Code** ```python Example0 import requests url = "https://api.x.flatfile.com/v1/sheets/us_sh_YOUR_ID/cells" querystring = {"distinct":"true","fieldKey":"firstName","sortField":"firstName","sortDirection":"asc","filter":"valid"} headers = { "X-Disable-Hooks": "true", "Authorization": "Bearer " } response = requests.get(url, headers=headers, params=querystring) print(response.json()) ``` ```typescript Example0 import { FlatfileClient } from "@flatfile/api"; const client = new FlatfileClient({ token: "YOUR_TOKEN" }); await client.sheets.getCellValues("us_sh_YOUR_ID", { distinct: true, fieldKey: "firstName", sortField: "firstName", sortDirection: "asc", filter: "valid" }); ``` ```go Example0 package main import ( "fmt" "net/http" "io" ) func main() { url := "https://api.x.flatfile.com/v1/sheets/us_sh_YOUR_ID/cells?distinct=true&fieldKey=firstName&sortField=firstName&sortDirection=asc&filter=valid" req, _ := http.NewRequest("GET", url, nil) req.Header.Add("X-Disable-Hooks", "true") req.Header.Add("Authorization", "Bearer ") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby Example0 require 'uri' require 'net/http' url = URI("https://api.x.flatfile.com/v1/sheets/us_sh_YOUR_ID/cells?distinct=true&fieldKey=firstName&sortField=firstName&sortDirection=asc&filter=valid") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Get.new(url) request["X-Disable-Hooks"] = 'true' request["Authorization"] = 'Bearer ' response = http.request(request) puts response.read_body ``` ```java Example0 import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.get("https://api.x.flatfile.com/v1/sheets/us_sh_YOUR_ID/cells?distinct=true&fieldKey=firstName&sortField=firstName&sortDirection=asc&filter=valid") .header("X-Disable-Hooks", "true") .header("Authorization", "Bearer ") .asString(); ``` ```php Example0 request('GET', 'https://api.x.flatfile.com/v1/sheets/us_sh_YOUR_ID/cells?distinct=true&fieldKey=firstName&sortField=firstName&sortDirection=asc&filter=valid', [ 'headers' => [ 'Authorization' => 'Bearer ', 'X-Disable-Hooks' => 'true', ], ]); echo $response->getBody(); ``` ```csharp Example0 using RestSharp; var client = new RestClient("https://api.x.flatfile.com/v1/sheets/us_sh_YOUR_ID/cells?distinct=true&fieldKey=firstName&sortField=firstName&sortDirection=asc&filter=valid"); var request = new RestRequest(Method.GET); request.AddHeader("X-Disable-Hooks", "true"); request.AddHeader("Authorization", "Bearer "); IRestResponse response = client.Execute(request); ``` ```swift Example0 import Foundation let headers = [ "X-Disable-Hooks": "true", "Authorization": "Bearer " ] let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/sheets/us_sh_YOUR_ID/cells?distinct=true&fieldKey=firstName&sortField=firstName&sortDirection=asc&filter=valid")! as URL, cachePolicy: .useProtocolCachePolicy, timeoutInterval: 10.0) request.httpMethod = "GET" request.allHTTPHeaderFields = headers let session = URLSession.shared let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in if (error != nil) { print(error as Any) } else { let httpResponse = response as? HTTPURLResponse print(httpResponse) } }) dataTask.resume() ```